var center = { latitude: 42.677297, longitude: 13.817831 }; /* centro della Mappa */
var waitAfterLoadingApp = 1000;
function cloneObj(obj) {
  if (null === obj || "object" != typeof obj) return obj;
  var copy = obj.constructor();
  for (var attr in obj) {
    if (obj.hasOwnProperty(attr)) copy[attr] = obj[attr];
  }
  return copy;
}
function findIndexObj(array, prop, value) {
  for (var i = 0; i < array.length; i++) {
    if(array[i][prop] == value) return i;
  }
  return -1;
}
function mySearchString(obj, toCompare, props){
  var found = false;
  toCompare = toCompare.split(/\s+/);
  for (var i = 0; i < toCompare.length; i++) {
    if(toCompare[i] === '') continue;
    found = false;
    for(var j = 0; j < props.length && !found; j++){
      if(obj[props[j]].toLowerCase().indexOf(toCompare[i].toLowerCase())!=-1) found = true;
    }
    if(!found) break;
  }
  return found;
}
function mySearchNumber(obj, toCompare, props){
  var found = false;
  for (var i = 0; i < props.length && !found; i++) {
    if(parseFloat(obj[props[i]]) == parseFloat(toCompare)) found = true;
  }
  return found;
}
function animateOverlayLoadingApp(){
  if(document.querySelector('.overlayLoadingApp').style.left != '-200%') {
    setTimeout(function(){
      document.querySelector('.overlayLoadingApp').style.left = '-200%';
    }, waitAfterLoadingApp);
  }
}
function triggerResize(){
  var evt = document.createEvent('UIEvents');
  evt.initUIEvent('resize', true, false, window, 0);
  window.dispatchEvent(evt);
}
(function(){
  angular.module('appCastellaltoFestival', ['ionic', 'ngCordova', 'ngStorage', 'uiGmapgoogle-maps'])
  .run(function($ionicPlatform){
    $ionicPlatform.ready(function() {
    });
  })
  .config(function($stateProvider, $urlRouterProvider) {

    $stateProvider
    .state('index', {
      url: "/",
      templateUrl: "mappa.html"
    })
    .state('cerca', {
      url: "/cerca",
      templateUrl: "cerca.html"
    })
    .state('programma', {
      url: "/programma",
      templateUrl: "programma.html"
    })
    .state('gastronomia', {
      url: "/gastronomia",
      templateUrl: "gastronomia.html"
    })
    .state('informazioni', {
      url: "/informazioni",
      templateUrl: "informazioni.html"
    })
    .state('regolamento', {
      url: "/regolamento",
      templateUrl: "regolamento.html"
    })
    .state('orari-di-chiusura', {
      url: "/orari-di-chiusura",
      templateUrl: "orari-di-chiusura.html"
    })
    .state('chi-siamo', {
      url: "/chi-siamo",
      templateUrl: "chi-siamo.html"
    })
    .state('credits', {
      url: "/credits",
      templateUrl: "credits.html"
    })
    .state('infoBirra', {
      url: "/infoBirra/:index",
      templateUrl: "infoBirra.html",
      reloadOnSearch: true
    })
    .state('infoStand', {
      url: "/infoStand/:index",
      templateUrl: "infoStand.html",
      reloadOnSearch: true
    });

   $urlRouterProvider.otherwise("/");

  })
  .controller('MainCtrl', function($scope, $rootScope, $http, $timeout, uiGmapIsReady, $ionicPlatform, $cordovaGeolocation, $cordovaNetwork, $ionicSideMenuDelegate, $localStorage, $window, $location, $interval, $ionicScrollDelegate){

    $rootScope.stands = [];
    $rootScope.birre = [];
    $rootScope.tipologie = [];
    $rootScope.provenienze = [];
    $rootScope.markers = [];
    $rootScope.mapLoaded = false;

    $ionicPlatform.ready(function() {
      if($cordovaNetwork.isOffline()) {
        if($localStorage.stands === undefined) {
          document.querySelector('.msgLoading').style.display = 'none';
          document.querySelector('.msgFirstTime').style.display = 'block';
        }
        else{
          if($localStorage.stands) $rootScope.stands = $localStorage.stands;
          if($localStorage.birre) $rootScope.birre = $localStorage.birre;
          if($localStorage.markers) $rootScope.markers = $localStorage.markers;
          if($localStorage.tipologie) $rootScope.tipologie = $localStorage.tipologie;
          if($localStorage.provenienze) $rootScope.provenienze = $localStorage.provenienze;

          animateOverlayLoadingApp();
        }
      }
      else {
        $scope.requests();
      }
    });

    $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
      document.querySelector('.msgLoading').style.display = 'block';
      document.querySelector('.msgFirstTime').style.display = 'none';

      if(!$rootScope.mapLoaded) {
        document.location = "index.html"; /* refresh app */
        return;
      }

      $timeout(function(){
        triggerResize();
      }, 0);

      $scope.requests();
    });
/*
    $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){

    });
*/
    $scope.requests = function(){

      var req = {
        method: 'GET',
        url: 'http://app.festivalbirreartigianali.it/getStandsWithBeers'
      };

      $http(req)
      .success(function(data, status, headers, config){
        $rootScope.stands = data;
        $rootScope.birre = [];
        $rootScope.markers = [];
        for(var i = 0, length1 = $rootScope.stands.length; i < length1; i++){
          var icon = 'img/' + (($rootScope.stands[i].icona_marker) ? $rootScope.stands[i].icona_marker : 'bar.png');
          var marker = { id: i, latitude: $rootScope.stands[i].latitudine, longitude: $rootScope.stands[i].longitudine, title: $rootScope.stands[i].nome, index: i, icon: icon };
          $rootScope.markers.push(marker);
        }
        for(i = 0, length1 = $rootScope.stands.length; i < length1; i++){
          $rootScope.stands[i].index = i;
          for(var j = 0, length2 = $rootScope.stands[i].birre.length; j < length2; j++){
            var obj = $rootScope.stands[i].birre[j];
            obj.standIndex = i;
            obj.index = $rootScope.birre.length;
            $rootScope.stands[i].birre[j].index = $rootScope.birre.length;
            $rootScope.birre.push(obj);
          }
        }
        $localStorage.stands = $rootScope.stands;
        $localStorage.birre = $rootScope.birre;
        $localStorage.markers = $rootScope.markers;
        animateOverlayLoadingApp();
      })
      .error(function(data, status, headers, config){
        console.log('Errore: '+data);
        animateOverlayLoadingApp();
      });

      req = {
        method: 'GET',
        url: 'http://app.festivalbirreartigianali.it/getProvenienze'
      };

      $http(req)
      .success(function(data, status, headers, config){
        $rootScope.provenienze = data;
        $localStorage.provenienze = $rootScope.provenienze;
      })
      .error(function(data, status, headers, config){
        console.log('Errore: '+data);
      });

      req = {
        method: 'GET',
        url: 'http://app.festivalbirreartigianali.it/getTipologie'
      };

      $http(req)
      .success(function(data, status, headers, config){
        $rootScope.tipologie = data;
        $localStorage.tipologie = $rootScope.tipologie;
      })
      .error(function(data, status, headers, config){
        console.log('Errore: '+data);
      });
    };

    $scope.goToInfoStand = function(instance, event, marker){
      if(marker.title !== '') $location.path('/infoStand/'+marker.index);
    };

    $rootScope.map = {
      center: cloneObj(center),
      zoom: 18,
      control: {},
      show: true,
      refresh: false
    };
    $scope.styles = [{
      featureType: "poi",
      stylers: [
        { visibility: "off" }
      ]
    }];
    $scope.options = {scrollwheel: false};

    $rootScope.directionsDisplay = undefined;

    $rootScope.stand = null;

    if(typeof google === 'object' && typeof google.maps === 'object') {

      $rootScope.mapLoaded = true;

      $rootScope.directionsDisplay = new google.maps.DirectionsRenderer();

      uiGmapIsReady.promise().then(function() {

        $rootScope.directionsDisplay = new google.maps.DirectionsRenderer();

        $scope.calcRoute = function (endRoute) {
          $scope.end = endRoute;
          $rootScope.directionsDisplay.setMap(null);
          $rootScope.directionsDisplay.setMap($rootScope.map.control.getGMap());
          var directionsService = new google.maps.DirectionsService();
          var start = $scope.fromAddress;
          var end = $scope.end;
          var request = {
            origin: start,
            destination: end,
            travelMode: google.maps.TravelMode[$rootScope.stand.travelMode]
          };
          directionsService.route(request, function(response, status) {
            if (status == google.maps.DirectionsStatus.OK) {
              $rootScope.directionsDisplay.setDirections(response);
            }
          });
        };

      });
    }

    $ionicPlatform.ready(function() {

      $rootScope.$watch('stand', function(){
        if ($rootScope.stand !== null) {
          document.querySelector('.overlay').style.display = 'block';

          var posOptions = {timeout: 10000, enableHighAccuracy: false};
          $cordovaGeolocation.getCurrentPosition(posOptions).then(function (position) {
              var pos = new google.maps.LatLng(position.coords.latitude,
                                               position.coords.longitude);
              $scope.fromAddress = pos;
              $scope.calcRoute($rootScope.stand.latitudine+','+$rootScope.stand.longitudine);
              $rootScope.stand = null;
              document.querySelector('.overlay').style.display = 'none';
          },
          function(error){
            alert('Abilitare la Geolocalizzazione!');
            $rootScope.stand = null;
            document.querySelector('.overlay').style.display = 'none';
          });
        }

      });

    });

    $rootScope.$on( "$ionicView.enter", function( scopes, states ) {
      if(states.stateName === 'index') {
        $timeout(function(){
          triggerResize();
        }, 0);
      }
      else if(states.stateName === 'infoBirra' || states.stateName === 'infoStand') {
        $ionicScrollDelegate.$getByHandle('myScroll').scrollTop(true);
      }
    });

    $scope.toggleRight = function() {
      $ionicSideMenuDelegate.toggleRight();
    };

  })
  .controller('CercaCtrl', function($scope, $ionicScrollDelegate){
    $scope.queryBeer = '';
    $scope.searchBeer = function (birra){
      if(!birra || $scope.queryBeer === '') return true;
      return mySearchString(birra, $scope.queryBeer, ['nome_birra', 'nome_birrificio', 'colore', 'gradazione_alcolica']);
    };

    $scope.queryBeerByProvenienza = '';
    $scope.searchBeerByProvenienza = function (birra){
      if(!birra || $scope.queryBeerByProvenienza === '') return true;
      return mySearchNumber(birra, $scope.queryBeerByProvenienza, ['provenienza_id']);
    };

    $scope.queryBeerByTipologia = '';
    $scope.searchBeerByTipologia = function (birra){
      if(!birra || $scope.queryBeerByTipologia === '') return true;
      return mySearchNumber(birra, $scope.queryBeerByTipologia, ['tipologia_id']);
    };

    $scope.queryBeerByStand = '';
    $scope.searchBeerByStand = function (birra){
      if(!birra || $scope.queryBeerByStand === '') return true;
      return mySearchNumber(birra, $scope.queryBeerByStand, ['stand_id']);
    };

    $scope.resetQueryBeer = function(){
      $scope.queryBeer = '';
    };

    $scope.scrollTop = function(){
      $ionicScrollDelegate.$getByHandle('myBeerScroll').scrollTop();
    };
  })
  .controller('MyMapCustomControlCtrl', function($scope, $rootScope, $stateParams, $ionicPlatform, $cordovaGeolocation, $timeout){

    $scope.goToCenter = function(){
      $rootScope.map.center = cloneObj(center);
      $rootScope.map.zoom = 18;
    };

    $scope.hideRoute = function(){
      if($rootScope.directionsDisplay !== undefined) $rootScope.directionsDisplay.setMap(null);
      $rootScope.stand = null;
    };

    $ionicPlatform.ready(function() {
      $scope.findMe = function(){

        document.querySelector('.overlay').style.display = 'block';

        var posOptions = {timeout: 10000, enableHighAccuracy: false};

          $cordovaGeolocation.getCurrentPosition(posOptions).then(function (position) {

            var lastMarker = null;
            if($rootScope.markers.length > 0){
              lastMarker = $rootScope.markers[$rootScope.markers.length-1];
            }
            if(lastMarker !== null && lastMarker.title === '') {
              lastMarker.latitude = position.coords.latitude;
              lastMarker.longitude = position.coords.longitude;
              $rootScope.markers[$rootScope.markers.length-1] = lastMarker;
            }
            else {
              var marker = { id: $rootScope.markers.length, latitude: position.coords.latitude, longitude: position.coords.longitude, title: '', index: $rootScope.markers.length, icon: 'img/person.png' };
              $rootScope.markers.push(marker);
            }
            $rootScope.map.center = { latitude: position.coords.latitude, longitude: position.coords.longitude };
            $rootScope.map.zoom = 18;
            document.querySelector('.overlay').style.display = 'none';

          },
          function(error){
            alert('Abilitare la Geolocalizzazione!');
            document.querySelector('.overlay').style.display = 'none';
          });
        };
    });
  })
  .controller('infoBirraCtrl', function($scope, $rootScope, $stateParams){
    var index = parseInt($stateParams.index);
    if($rootScope.birre[index]) {
      $scope.birra = $rootScope.birre[index];
    }
  })
  .controller('infoStandCtrl', function($scope, $rootScope, $stateParams, $cordovaNetwork){
    var index = parseInt($stateParams.index);
    if($rootScope.stands[index]) {
      $scope.stand = $rootScope.stands[index];
    }
    $scope.travelMode = function(travelMode){
      if($cordovaNetwork.isOnline() && $rootScope.mapLoaded){
         $rootScope.stand = $scope.stand;
         $rootScope.stand.travelMode = travelMode;
       }
      else{
        alert('Connessione assente!');
      }
    };
  })
  .directive('setHeight', function($rootScope){
    return {
      link: function(scope, elem){
        if(document.querySelector('.angular-google-map-container')) {
          document.querySelector('.angular-google-map-container').style.height = window.innerHeight-document.querySelector('.tabs').getBoundingClientRect().height-document.querySelector('.myHeaderBar').getBoundingClientRect().height+'px';
        }
        window.onresize = function(){
          if(document.querySelector('.angular-google-map-container')) {
            document.querySelector('.angular-google-map-container').style.height = window.innerHeight-document.querySelector('.tabs').getBoundingClientRect().height-document.querySelector('.myHeaderBar').getBoundingClientRect().height+'px';
          }
          if(typeof google === 'object' && typeof google.maps === 'object') google.maps.event.trigger($rootScope.map.control.getGMap(), 'resize');
        };
      }
    };
  });
})();
